#include "Framework/Object.h"
#include "Engine/Engine.h"
#include "Log.h"
#include <memory>

Object::~Object()
{
    LOG_INFO("Destroying object: {0}", GetName());
}

void Object::Init()
{
    BaseObject::Init();
    
    FluxEngine* engine = GetEngine();
    if (!engine)
    {
        LOG_ERROR("Failed to initialize object: {0}", GetName());
        return;
    }

    engine->GetGarbageCollector().AddObject(shared_from_this());
}