#pragma once

#include "Core.h"
#include <memory>
#include <vector>

#include "Framework/BaseObject.h"

class FluxEngine;
class Object;

class GarbageCollector : public BaseObject
{
public:
    FLUX_API explicit GarbageCollector(FluxEngine* engine);
    FLUX_API ~GarbageCollector();

    FLUX_API void AddObject(std::shared_ptr<Object> ObjectToAdd);
    FLUX_API void RemoveObject(std::shared_ptr<Object> ObjectToRemove);

    FLUX_API void CollectGarbage();

protected:
    virtual void Init() override;

private:
    std::vector<std::shared_ptr<Object>> _RootObjects;
};