﻿#pragma once

#include <memory>
#include <string>

#include "Core.h"

namespace spdlog
{
    class logger;
}

struct LoggerImpl;

class FLUX_API Logger
{
public:
    Logger();
    ~Logger();

    void LogTrace(const std::string& message);
    void LogInfo(const std::string& message);
    void LogWarn(const std::string& message);
    void LogError(const std::string& message);
    void LogFatal(const std::string& message);

private:
    spdlog::logger* GetLogger() const;

    LoggerImpl& _impl;
};

#define LOG_TRACE(message) ::FluxEngine::GetLogger()->LogTrace(message)
#define LOG_INFO(message) ::FluxEngine::GetLogger()->LogInfo(message)
#define LOG_WARN(message) ::FluxEngine::GetLogger()->LogWarn(message)
#define LOG_ERROR(message) ::FluxEngine::GetLogger()->LogError(message)
#define LOG_FATAL(message) ::FluxEngine::GetLogger()->LogFatal(message)
