#include "Flux.h"
#include "Framework/Object.h"

class SandboxObject : public Object
{
public:
	SandboxObject() = default;
	virtual ~SandboxObject() = default;

	virtual void Init() override
	{
		Object::Init();
		LOG_INFO("SandboxObject Initialized: {0}", GetName());
	}
};

class Sandbox : public FluxEngine
{
public:
	Sandbox() = default;
	virtual ~Sandbox() = default;

	virtual void Init() override
	{
		FluxEngine::Init();
		
		std::shared_ptr<SandboxObject> Obj = Object::NewObject<SandboxObject>();
	}
};

int main(int argc, char** argv)
{
	std::unique_ptr<Sandbox> app = FluxEngine::CreateApplication<Sandbox>();
	app->Init();
	return app->Start();
}